;***************************************************************************
;*																		   *
;*							INSTALL.S									   *
;*																		   *
;*						Version vom 30.6.93								   *
;*																		   *
;***************************************************************************


;---------------------------------------------------------------------------
; Globale Symbole
;---------------------------------------------------------------------------


	.IMPORT		_BasPag						; Adresse der Basepage der
											; Accessory
	.EXPORT		Install						; Adresse der Routine
	.IMPORT		Counter						; Zhler
	.IMPORT		Is_VB						; Installationsflag
	.IMPORT		Was_Vb						; wird durch VBIs gelscht
	.IMPORT		frame_size					; Framegre bei TRAP's


;---------------------------------------------------------------------------
; Definition von Symbolen
;---------------------------------------------------------------------------


nvbls		.EQU	$000454					; Maximalzahl der VBI-Routinen
_vblqueue	.EQU	$000456					; Adresse der VBI-Tabelle
hdv_rw		.EQU	$000476					; Entry-Point bei Plattenzu-
											; zugriffen
ikbd_entry	.EQU	$000118					; Entry-Point bei IKBD/MIDI-In-
											; terrupts
trap_14		.EQU	$0000B8					; Entry-Point fr Xbios
trap_1		.EQU	$000084					; TRAP#1-Vektor


			.SUPER
			.TEXT


;---------------------------------------------------------------------------
; Installations-Routine
;---------------------------------------------------------------------------


Install:

		move.w	nvbls, d1				; Maximalzahl der Eintrge in der
										; VBI-Tabelle holen
		movea.l	_vblqueue, a1			; Adresse der VBI-Tabelle holen
		adda.l	#4, a1					; erster Eintrag mu frei bleiben !
		subq.w	#1, d1					; Zhler entsprechend dekrementieren

test_table:

		tst.l	(a1)					; Eintrag der VBI-Tabelle testen
		beq.b	free_entry				; freier Eintrag gefunden
		subq.w	#1, d1					; Anzahl der freien Eintrge dekre-
										; mentieren
		beq.b	no_free_entry			; kein Eintrag mehr frei -> Abbruch
		addq.l	#4, a1					; Pointer auf Tabelle erhhen
		bra.b	test_table				; nchsten Eintrag untersuchen

free_entry:
 
		move.l	#inc_counter, (a1)		; eigene Routine in freien Eintrag
										; in der VBI-Tabelle schreiben
		bsr.b	exc_ikbd				; neuen Handler fr IKBD/MIDI-Inter-
										; rupts setzen
		bsr.b	exc_hdv					; neuen Handler fr Plattenzu-
										; griffe setzen
		bsr.w	exc_t14					; neuen Handler fr Xbios-Aufrufe
										; setzen
		bsr.w	set_trap_1

		move.w	#1, Is_VB				; Flag fr erfolgreichen Abschlu
										; der Installation setzen
		rts								; Routine beenden


no_free_entry:

		clr.w	Is_VB					; Flag lschen
		rts								; Routine beenden


;---------------------------------------------------------------------------
; Routine zum Inkrementieren des Zhlers bei VB-Interrupts
;---------------------------------------------------------------------------


inc_counter:

		addq.l	#1, Counter				; VB-Interrupt-Zhler inkrementieren
		clr.w	Was_Vb					
		rts								; und schon fertig


;---------------------------------------------------------------------------
; Routine zum Umlenken von IKBD/MIDI-Interupts
;---------------------------------------------------------------------------


exc_ikbd:

		pea		(new_ikbd, pc)				; neuen Entrypoint -> Stack
		move.w	#$46, -(a7)					; Vektoradresse fr IKBD-IRs
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur
		move.l	d0, old_ikbd				; alten Entrypoint sichern
		rts

		
;---------------------------------------------------------------------------
; Routine zum Abfangen von IKBD/MIDI-Interrupts
;---------------------------------------------------------------------------


			.DC.B	'XBRA'					; XBRA fr IKBD/MIDI-Interrupts
			.DC.B	'jtsb'
old_ikbd:	.DC.L	0						; Adresse des ursprnglichen
											; IKBD/MIDI-Handlers
new_ikbd:

		tst.l	Counter						; testen, ob Zhler negativ
		bmi.b	ikbd_ready					; wenn ja abbrechen

		clr.l	Counter						; sonst erst Zhler zurcksetzen

ikbd_ready:

		move.l	old_ikbd, -(a7)				; alte Interrupt-Handler-Adresse
		rts									; als Return-Adresse auf Stack


;---------------------------------------------------------------------------
; Routine zum Umlenken von Schreib- und Lesezugriffen auf eine Platte
;---------------------------------------------------------------------------


exc_hdv:

		move.l	hdv_rw, d0					; alten Handler bei Zugriffen
		move.l	d0, old_hdv_rw				; sichern
		lea.l	(new_hdv_rw, pc), a0		; neuen Handler setzen
		move.l	a0, hdv_rw
		rts

		
;---------------------------------------------------------------------------
; Routine zum Abfangen von Schreib- und Lesezugriffen auf eine Platte
;---------------------------------------------------------------------------


			.DC.B	'XBRA'					; XBRA fr hdv_rw-Umlenkung
			.DC.B	'jtsb'
old_hdv_rw:	.DC.L	0						; alte Adresse des Vektors
											; bei Plattenzugriffen
new_hdv_rw:

		tst.l	Counter						; testen, ob Zhler negativ
		bmi.b	hdv_rw_ready				; wenn ja abbrechen

		clr.l	Counter						; sonst erst Zhler zurcksetzen

hdv_rw_ready:

		move.l	old_hdv_rw, -(a7)			; alten Plattenzugriffs-Handler
		rts									; als Return-Adresse auf Stack


;---------------------------------------------------------------------------
; Routine zum Umlenken von Xbios-Aufrufen
;---------------------------------------------------------------------------


exc_t14:

		pea		(new_t14, pc)				; neuen Entrypoint -> Stack
		move.w	#$2E, -(a7)					; Vektoradresse von TRAP 14
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur
		move.l	d0, old_t14					; alten Entrypoint sichern
		rts

		
;---------------------------------------------------------------------------
; Routine zum Abfangen von Jenabint(0x0D) und Jdisint(0x0D)
; sowie nderungen der Bildschirmuflsung mittels Setscreen()
;---------------------------------------------------------------------------


			.DC.B	'XBRA'					; XBRA fr Xbios-Umlenkung
			.DC.B	'jtsb'
old_t14:	.DC.L	0						; Adresse des ursprnglichen
											; Xbios-Aufruf-Handlers
new_t14:

		btst.b	#5, (a7)					; Aufruf im Supervisor-Mode ?
		bne.b	s_trap_14					; wenn ja

		move.l	usp, a0						; A0 mit Userstackpointer laden
		bra.b	test_Jdisint

s_trap_14:

		move.l	a7, a0						; A0 mit Supervisorstackpointer
		add.l	frame_size, a0				; laden + Offsetkorrektur

test_Jdisint:

		cmpi.l	#$1A000D, (a0)				; Jdisint(TIMER_A)-Aufruf ?
		bne.b	test_Jenabint				; wenn nicht

		clr.l	Counter						; Zhler wieder auf Null setzen
		bra.b	t14_ready

test_Jenabint:

		cmpi.l	#$1B000D, (a0)				; Jenabint(TIMER_A)-Aufruf ?
		bne.b	t14_ready					; wenn nicht

		move.l	#$80000000, Counter			; Zhler mit grtmglichem
											; negativen Wert besetzen
t14_ready:

		move.l	old_t14, -(a7)				; alten Xbios-Aufruf-Handler
		rts									; als Return-Adresse auf Stack


;---------------------------------------------------------------------------
; Routine zum Umlenken von GEMDOS-Aufrufen
;---------------------------------------------------------------------------


set_trap_1:

		pea		(trap_1_handler, pc)		; neuen Entrypoint -> Stack
		move.w	#$21, -(a7)					; Vektoradresse von TRAP 1
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur
		move.l	d0, old_trap_1				; alten Entrypoint sichern
		rts


;---------------------------------------------------------------------------
; Routine zum Abfangen von Mfree()-Aufrufen, die den dr die Accessory
; reservierten Seicher wieder freigeben - dies erfolgt bei einem Auf-
; lsungsnderung und vorher mssen alle verbogenen Systemvektoren wieder
; 'zurckgebogen' werden
;---------------------------------------------------------------------------

			.DC.B	'XBRA'					; XBRA fr TRAP#1
			.DC.B	'jtsb'
old_trap_1:
			.DC.L	0						; Adresse des ursprnglichen
											; TRAP#1-Handlers

trap_1_handler:

		btst.b	#5, (a7)					; Supervisor-Bit des geretteten
											; SR gesetzt ?
		bne.b	s_trap_1					; wenn ja

		move.l	usp, a0						; A0 mit Userstackpointer laden
		bra.b	trap_1_test

s_trap_1:

		move.l	a7, a0						; A0 mit Supervisorstackpointer
		add.l	frame_size, a0				; laden + Offsetkorrektur

trap_1_test:

		cmpi.w	#$49, (a0)					; Mfree() ?
		bne.b	trap_1_leave				; Abbruch wenn nicht
		move.l	$2(a0), d0					; Adresse des freizugebenden
											; Speicherbereichs holen
		cmp.l	_BasPag, d0					; Basepage der Accessory ?
		bne.b	trap_1_leave				; Abbruch wenn nicht

		bsr.w	deinstall					; Programm deinstallieren

trap_1_leave:

		move.l	(old_trap_1, pc), a0		; zum ursprnglichen TRAP#1-
		jmp		(a0)						; Handler springen


;---------------------------------------------------------------------------
; Routine zum 'Zurckbiegen' aller durch die Accessory verbogenen System-
; vektoren - soweit mglich werden XBRA's bercksichtigt
;---------------------------------------------------------------------------


deinstall:

reset_trap_1:

		movea.l	trap_1, a0					; Eintrag im TRAP#1-Vektor holen
		cmpa.l	#trap_1_handler, a0			; Adresse des eigenen Handlers ?
		beq.b	set_trap_1_orig				; wenn ja

loop_trap_1:

		move.l	-12(a0), d0					; XBRA-Kennung holen und testen
		cmpi.l	#'XBRA', d0
		bne.b	set_trap_1_orig				; bei unterbrochener XBRA-Kette

		movea.l	a0, a1						; letzen Eintrag merken
		movea.l	-4(a0), a0					; nchste Adresse holen
		cmpa.l	#trap_1_handler, a0			; Adresse des eigenen Handlers ?
		bne.b	loop_trap_1					; wenn nicht

		move.l	old_trap_1, -4(a1)			; Adresse in XBRA-Eintrag ndern
		bra.b	reset_ikbd					; und fertig

set_trap_1_orig:

		move.l	old_trap_1, -(a7)			; alten Entrypoint -> Stack
		move.w	#$21, -(a7)					; Vektoradresse von TRAP 1
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur

reset_ikbd:

		movea.l	ikbd_entry, a0				; Eintrag im IKBD-Vektor holen
		cmpa.l	#new_ikbd, a0				; Adresse des eigenen Handlers ?
		beq.b	set_ikbd_orig				; wenn ja

loop_ikbd:

		move.l	-12(a0), d0					; XBRA-Kennung holen und testen
		cmpi.l	#'XBRA', d0
		bne.b	set_ikbd_orig				; bei unterbrochener XBRA-Kette

		movea.l	a0, a1						; letzen Eintrag merken
		movea.l	-4(a0), a0					; nchste Adresse holen
		cmpa.l	#new_ikbd, a0				; Adresse des eigenen Handlers ?
		bne.b	loop_ikbd					; wenn nicht

		move.l	old_ikbd, -4(a1)			; Adresse in XBRA-Eintrag ndern
		bra.b	reset_trap_14				; und fertig

set_ikbd_orig:

		move.l	old_ikbd, -(a7)				; alten Entrypoint -> Stack
		move.w	#$46, -(a7)					; Vektoradresse fr IKBD-ITRs
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur

reset_trap_14:

		movea.l	trap_14, a0					; Eintrag im TRAP#14-Vektor
											; holen
		cmpa.l	#new_t14, a0				; Adresse des eigenen Handlers ?
		beq.b	set_trap_14_orig			; wenn ja

loop_trap_14:

		move.l	-12(a0), d0					; XBRA-Kennung holen und testen
		cmpi.l	#'XBRA', d0
		bne.b	set_trap_14_orig			; bei unterbrochener XBRA-Kette

		movea.l	a0, a1						; letzen Eintrag merken
		movea.l	-4(a0), a0					; nchste Adresse holen
		cmpa.l	#new_t14, a0				; Adresse des eigenen Handlers ?
		bne.b	loop_trap_14				; wenn nicht

		move.l	old_t14, -4(a1)				; Adresse in XBRA-Eintrag ndern
		bra.b	reset_hdv_rw				; und fertig

set_trap_14_orig:

		move.l	old_t14, -(a7)				; alten Entrypoint -> Stack
		move.w	#$2E, -(a7)					; Vektoradresse von TRAP 14
		move.w	#5, -(a7)					; Setexc()
		trap	#13							; Bios()
		addq.l	#8, a7						; Stackkorrektur

reset_hdv_rw:

		movea.l	hdv_rw, a0					; Eintrag in hdv_rw holen
		cmpa.l	#new_hdv_rw, a0				; Adresse des eigenen Handlers ?
		beq.b	set_hdv_rw_orig				; wenn ja

loop_hdv_rw:

		move.l	-12(a0), d0					; XBRA-Kennung holen und testen
		cmpi.l	#'XBRA', d0
		bne.b	set_hdv_rw_orig				; bei unterbrochener XBRA-Kette

		movea.l	a0, a1						; letzen Eintrag merken
		movea.l	-4(a0), a0					; nchste Adresse holen
		cmpa.l	#new_hdv_rw, a0				; Adresse des eigenen Handlers ?
		bne.b	loop_hdv_rw					; wenn nicht

		move.l	old_hdv_rw, -4(a1)			; Adresse in XBRA-Eintrag ndern
		bra.b	clear_vbi_list				; und fertig

set_hdv_rw_orig:

		move.l	old_hdv_rw, d0				; alten Handler fr Platten-
		move.l	d0, hdv_rw					; zugriffen zrcksetzen

clear_vbi_list:

		move.w	nvbls, d1					; Maximalzahl der Eintrge in
											; der VBI-Tabelle holen
		movea.l	_vblqueue, a2				; Adresse der VBI-Tabelle holen
		lea		(inc_counter, pc), a1		; Adresse von 'inc_counter'
											; besorgen

search_loop:

		cmpa.l	(a2), a1					; Eintrag in der VBI-Tabelle mit 
											; eigener Adresse vergleichen
		beq.b	entry_found					; lschen wenn gefunden
		subq.w	#1, d1						; Eintragszhler dekrementieren
		beq.b	entry_not_found				; 'inc_counter' ist nicht in der
											; Tabelle
		addq.l	#4, a2						; nchsten Eintrag untersuchen
		bra.b	search_loop

entry_found:

		clr.l	(a2)						; eigenen Eintrag lschen

entry_not_found:

		rts									; Ende der Routine