/**************************************************************************/
/*																		  */
/*							 S_BALL.C									  */
/*																		  */
/*						Version vom 11.12.93							  */
/*																		  */
/**************************************************************************/


#include <tos.h>
#include <aes.h>
#include <vdi.h>
#include <math.h>
#include <string.h>
#include "s_ball.rsh"


/*######################################################################*/
/* Hier sollte bei der ST-Version 72 (d.h. 72 VBI's pro Sekunde) stehen */
/* und in der TT-Version 60 (den Wert fr den Falcon wei ich nicht)	*/
/*######################################################################*/

#define VBI_per_sec	60						/* Anzahl der Vertical-Blank- */
											/* Interrupts pro Sekunde	  */

#define EPSILON		1.0E-12					/* Rechengenauigkeit		  */

#define MAX(x,y)	(((x) > (y)) ? (x) : (y))	 /* Maximum zweier Zahlen */
#define MIN(x,y)	(((x) < (y)) ? (x) : (y))	 /* Minimum zweier Zahlen */


/**************************************************************************/
/*																		  */
/*			Funktionsdeklarationen										  */
/*																		  */
/**************************************************************************/


long Install(void);					   /* Assembler-Routine, s. INSTALL.S */
void ball(void);
void calc_new_pos(void);
int gem_init(void);
void edit_parameter(void);
double get_rand(void);
void i_to_a(char *str, int time);


/**************************************************************************/
/*																		  */
/*		globale Variable												  */
/*																		  */
/**************************************************************************/


volatile long Counter = 0;		  /* Zhler, wird bei jedem VBI inkremen- */
								  /* tiert und durch Maus- oder Tastatur- */
								  /* ereignisse bzw. Plattenzugriffe auf  */
								  /* Null zurckgesetzt					  */
int Is_VB = 0;					  /* Flag, wird gesetzt wenn die Instal-  */
								  /* lation geklappt hat				  */

long max_count = VBI_per_sec * 60;	/* Anzahl der VBI's, bis S_BALL ge-	  */
									/* startet werden darf				  */

int ap_id,							/* ID der Applikation				  */
	wkst_handle;					/* Handle der Workstation			  */

int screen_width,					/* Bildschimbreite und -hhe sowie	  */
	screen_height,					/* die Anzahl der Farbebenen		  */
	nplanes;

volatile int Was_Vb;				/* wird gelscht, wenn ein VBI aufge- */
									/* treten ist						  */

/*#######################################################*/
/* Hier sollte bei der ST-Version 'num_balls = 3' stehen */
/* und in der TT-Version 'num_balls = 10'				 */
/*#######################################################*/

int num_balls = 10,					/* Anzahl der Kugeln sowie deren	  */
	r = 14,							/* Radius und Durchmesser (in Pixeln) */
	d = 27;

int act_screen = 0;					/* Nummer des gerade dargestellten	  */
									/* Bildschirms						  */
int right_max,						/* rechter und unterer Bildschirmrand */
	bottom_max;						/* minus Kugelradius				  */

int speed = 50;						/* maximale Startgeschwindigkeit der  */
									/* Kugeln (in Prozent)				  */
int *flag_1,						/* Arrays von Flags, die anzeigen, ob */
	*flag_2;						/* Sto der entsprechenden Kugel auf- */
									/* getreten ist						  */
double *x, *y,						/* Arrays fr Orte, Geschwindigkeiten */
	   *v_x, *v_y,					/* und Zeiten bis zum nchsten Sto	  */
	   *t_s;						/* der Kugeln						  */

/*#############################################################*/
/* Hier MUSS fr 68000-Prozessoren 'frame_size = 6L' stehen  ! */
/* und bei 68020 und grer (TT und Falcon) frame_size = 8L' ! */
/*#############################################################*/

long frame_size = 8L;				/* Stackframe-Gre bei TRAP-Excep-	  */
									/* tions							  */


/**************************************************************************/
/*																		  */
/*		Hauptroutine der Accessory										  */
/*																		  */
/**************************************************************************/


void main()
{
	int menu_id;								/* ID des Menueeintrags	  */
	int ev_type, ev_mwhich, dummy;
	int msg_buffer[8];
	int i;										/* Zhler				  */


	if (_app)						  /* Bei Start als Programm abbrechen */
		return;

	if ((ap_id = appl_init()) == -1)			/* Applikation anmelden   */
		return;									/* ... milungen		  */

	/* Resource-Objekte aus S_BALL.RSH mssen noch korregiert werden ...  */

	for (i = 0; i <= rs_object->ob_tail; i++)
	{
		if (rs_object[i].ob_type == G_BUTTON)
			rs_object[i].ob_spec.free_string =
									 rs_strings[rs_object[i].ob_spec.index];
		if (rs_object[i].ob_type == G_TEXT)
		{
			rs_object[i].ob_spec.tedinfo =
									rs_tedinfo + rs_object[i].ob_spec.index;

			rs_object[i].ob_spec.tedinfo->te_ptext =
						 rs_strings[rs_object[i].ob_spec.tedinfo->te_ptext];

			rs_object[i].ob_spec.tedinfo->te_ptmplt =
				 		rs_strings[rs_object[i].ob_spec.tedinfo->te_ptmplt];

			rs_object[i].ob_spec.tedinfo->te_pvalid =
				 		rs_strings[rs_object[i].ob_spec.tedinfo->te_pvalid];
		}

		rsrc_obfix(rs_object, i);
	}		

	if ((menu_id = menu_register(ap_id, "  S_BALL ...")) == -1)
	{
		appl_exit();
		return;
	}

	Supexec(Install);								 /* Siehe 'INSTALL.S' */

	if (Is_VB == 0)						/* hat es geklappt sich in den	  */
	{									/* VB-Interrupt zu hngen ?		  */
		appl_exit();
		return;
	}

	ev_type = MU_MESAG | MU_TIMER;

	for ( ; ; )
	{
		do
		{
			ev_mwhich = evnt_multi(ev_type, 0, 0, 0, 0, 0, 0, 0, 0,
								   0, 0, 0, 0, 0, msg_buffer, 1000, 0,
								   &dummy, &dummy, &dummy, &dummy, &dummy,
								   									&dummy);
		} while ((Counter < max_count) && (ev_mwhich == MU_TIMER));

		if ((ev_mwhich == MU_MESAG) && (msg_buffer[0] == AC_OPEN)
											  && (msg_buffer[4] == menu_id))
		{
			edit_parameter();
			if (max_count == 0)
				ev_type &= ~MU_TIMER;
			else
				ev_type |= MU_TIMER;
			if (max_count < 0)
			{
				max_count *= -1;
				Counter = max_count + 1;
			}
		}

		if (ev_mwhich == MU_TIMER)
			ball();
	}
}


void ball(void)
{
	void *old_phys_screen,
		 *old_log_screen,
		 *ptr;
	double a;
	MFDB old_screen, screen[2], k_1, k_2, m;
	int copy[8], *clear_new, *clear;
	int i, j, k, l;

	/* Bilder und Maske fr die Kugeln									  */

	int kug_1[] = {0x003F, 0x8000, 0x01FF, 0xF000, 0x03FF, 0xF800,
				   0x0FFF, 0xFE00, 0x1FFF, 0xFF00, 0x1EFF, 0xFF00,
				   0x3C7F, 0xFF80, 0x7EFF, 0xFFC0, 0x7FFF, 0xFFC0,
				   0x7FFF, 0xFFC0, 0xFFFF, 0xFFE0, 0xFFFF, 0xFF60,
				   0xFFFF, 0xFF60, 0xFFFF, 0xFEE0, 0xFFFF, 0xFC60,
				   0xFFFF, 0xFEE0, 0xFFFF, 0xF560, 0x7FFF, 0xF0C0,
				   0x7FFF, 0xE5C0, 0x7FFF, 0xC3C0, 0x3FFF, 0x0580,
				   0x1FFE, 0xAB00, 0x1FFD, 0x1700, 0x0FF0, 0xBE00,
				   0x03ED, 0x7800, 0x003F, 0x8000, 0x0000, 0x0000,
				   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
				   0x0000, 0x0000, 0x0000, 0x0000},
		kug_2[] = {0x003F, 0x8000, 0x01FF, 0xF000, 0x03FF, 0xF800,
				   0x0FFF, 0xFE00, 0x1FFF, 0xFF00, 0x1FFF, 0xFF00,
				   0x3EFF, 0xFF80, 0x7FFF, 0xFFC0, 0x7FFF, 0xFFC0,
				   0x7FFF, 0xFFC0, 0xFFFF, 0xFFE0, 0xFFFF, 0xFF60,
				   0xFFFF, 0xFF60, 0xFFFF, 0xFEE0, 0xFFFF, 0xFC60,
				   0xFFFF, 0xFEE0, 0xFFFF, 0xF560, 0x7FFF, 0xF0C0,
				   0x7FFF, 0xE5C0, 0x7FFF, 0xC3C0, 0x3FFF, 0x0580,
				   0x1FFE, 0xAB00, 0x1FFD, 0x1700, 0x0FF0, 0xBE00,
				   0x03ED, 0x7800, 0x003F, 0x8000, 0x0000, 0x0000,
				   0x0000, 0x0000, 0x0000, 0x0000, 0x0000, 0x0000,
				   0x0000, 0x0000, 0x0000, 0x0000},
		mask[] =  {0xFFC0, 0x7FFF, 0xFE00, 0x0FFF, 0xFC00, 0x07FF,
				   0xF000, 0x01FF, 0xE000, 0x00FF, 0xE000, 0x00FF,
				   0xC000, 0x007F, 0x8000, 0x003F, 0x8000, 0x003F,
				   0x8000, 0x003F, 0x0000, 0x001F, 0x0000, 0x001F,
				   0x0000, 0x001F, 0x0000, 0x001F, 0x0000, 0x001F,
				   0x0000, 0x001F, 0x0000, 0x001F, 0x8000, 0x003F,
				   0x8000, 0x003F, 0x8000, 0x003F, 0xC000, 0x007F,
				   0xE000, 0x00FF, 0xE000, 0x00FF, 0xF000, 0x01FF,
				   0xFC00, 0x07FF, 0xFFCF, 0x7FFF, 0xFFFF, 0xFFFF,
				   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF,
				   0xFFFF, 0xFFFF, 0xFFFF, 0xFFFF},
		 *n_kug_1, *n_kug_2, *n_mask;


	/* Workstation erffnen												  */

	if (gem_init() == 0)
		return;									 /* gescheitert -> Schlu */

	/* Speicher fr zwei neue Bildschirme besorgen						  */

	if ((ptr = Malloc((2L * nplanes * screen_width * screen_height >> 3)
															   + 256)) == 0)
	{
		v_clsvwk(wkst_handle);					/* Workstation schliessen */
		return;									/* ... und tsch		  */
	}

	/* Speicherplatz fr die Bilder der Kugeln besorgen					  */

	if ((n_kug_1 = (int *) Malloc(384L * nplanes)) == 0)
	{
		Mfree(ptr);
		v_clsvwk(wkst_handle);
		return;
	}

	/* Bilder der Kugeln im Speicher vorbereiten						  */

	n_kug_2 = n_kug_1 + nplanes * 64;
	n_mask = n_kug_2 + nplanes * 64;

	for (i = 0; i < 64; i++)
	{
		for (j = 0; j < nplanes; j++)
		{
			*(n_kug_1 + i * nplanes + j) = kug_1[i];
			*(n_kug_2 + i * nplanes + j) = kug_2[i];
			*(n_mask + i * nplanes + j) = mask[i];
		}
	}

	/* Speicherplatz fr verschieden Variable besorgen					  */

	if ((flag_1 = (int *) Malloc(num_balls * (14 * sizeof(int) + (4 +
							  (num_balls + 1) / 2) * sizeof(double)))) == 0) 
	{
		Mfree(n_kug_1);
		Mfree(ptr);
		v_clsvwk(wkst_handle);
		return;
	}
		
	flag_2 = flag_1 + num_balls;
	clear_new = flag_2 + num_balls;
	clear = clear_new + 4 * num_balls;
	x= (double *) (clear + 8 * num_balls);
	y = x + num_balls;
	v_x = y + num_balls;
	v_y = v_x + num_balls;
	t_s = v_y + num_balls;

	for (i = 0; i < num_balls; i++)
		flag_1[i] = 1;

	for (i = 0; i < (num_balls * (num_balls + 1)) / 2; i++)
		t_s[i] = HUGE_VAL;

	/* physikalische Bildschirmadresse setzen (sie mu auf 256-Byte-Gren- */
	/* ze liegen - zumindest bei ST's)									  */

	screen[0].fd_addr = (void *) (((long) ptr & 0xFFFFFF00L) + 256L);
	screen[1].fd_addr = (void *) ((long) screen[0].fd_addr +
					  ((long) nplanes * screen_width * screen_height >> 3));

	/* alte logische und physikalische Bildschirmadresse besorgen		  */

	old_phys_screen = Physbase();
	old_log_screen = Logbase();

	/* MFDB's und Array zum Kopieren vorbesetzen						  */

	old_screen.fd_addr = old_phys_screen;

	screen[0].fd_w = screen[1].fd_w = old_screen.fd_w = screen_width;
	screen[0].fd_h = screen[1].fd_h = old_screen.fd_h = screen_height;
	screen[0].fd_wdwidth = screen[1].fd_wdwidth = old_screen.fd_wdwidth =
														  screen_width >> 4;
	screen[0].fd_stand = screen[1].fd_stand = old_screen.fd_stand = 0;
	screen[0].fd_nplanes = screen[1].fd_nplanes = old_screen.fd_nplanes =
																	nplanes;

	copy[0] = copy[4] = copy[1] = copy[5] = 0;
	copy[2] = copy[6] = screen_width - 1;
	copy[3] = copy[7] = screen_height - 1;

	/* Inhalt des logischen Bildschirms (zweimal) in den allozierten	  */
	/* Speicher kopieren												  */

	v_hide_c(wkst_handle);

	vro_cpyfm(wkst_handle, S_ONLY, copy, &old_screen, screen);
	vro_cpyfm(wkst_handle, S_ONLY, copy, &old_screen, screen + 1);

	/* MFDB's Fr Kugeln und Maske vorbesetzen							  */

	k_1.fd_addr = (void *) n_kug_1;
	k_2.fd_addr = (void *) n_kug_2;
	m.fd_addr = (void *) n_mask;

	k_1.fd_w = k_2.fd_w = m.fd_w = 32;
	k_1.fd_h = k_2.fd_h = m.fd_h = 32;
	k_1.fd_wdwidth = k_2.fd_wdwidth = m.fd_wdwidth = 2;
	k_1.fd_stand = k_2.fd_stand = m.fd_stand = 0;
	k_1.fd_nplanes = k_2.fd_nplanes = m.fd_nplanes = nplanes;

	for (i = k = 0, l = 4; i < num_balls; i++, k = l, l += 4)
	{

	/* Koordinaten und Geschwindigkeiten der Kugeln bestimmen, dabei ver- */
	/* hindern, da zwei Kugeln berlappend erzeugt werden				  */

		do
		{
			x[i] = (screen_width  - 2 * (r + 1)) * get_rand() + r + 1;
			y[i] = (screen_height - 2 * (r + 1)) * get_rand() + r + 1;
		
			a = HUGE_VAL;
			for (j = 0; j < i; j++)
				a = MIN(a, sqrt((x[i] - x[j]) * (x[i] - x[j])
										  + (y[i] - y[j]) * (y[i] - y[j])));
		} while (a < (double) 2 * r);

		v_x[i] = 0.5 * (double) speed * (get_rand() - 0.5);
		v_y[i] = 0.5 * (double) speed *  (get_rand() - 0.5);

	/* Kugeln auf den neuen Bildschirm kopieren (erst die Maske per UND-  */
	/* Verknpfung, dann die Kugel per ODER-Verknpfung)				  */

		copy[0] = copy[1] = 0;
		copy[2] = copy[3] = d - 1;

		clear_new[4 * i] = clear[k++] = clear[l++] = copy[4] =
															 (int) x[i] - r;
		clear_new[4 * i + 1] = clear[k++] = clear[l++] = copy[5] =
															 (int) y[i] - r;
		clear_new[4 * i + 2] = clear[k++] = clear[l++] = copy[6] = 
														   clear[8 * i] + d;
		clear_new[4 * i + 3] = clear[k++] = clear[l++] = copy[7] =
													   clear[8 * i + 1] + d;

		vro_cpyfm(wkst_handle, S_AND_D, copy, &m, screen + act_screen);
		vro_cpyfm(wkst_handle, S_OR_D, copy, (((int) (x[i] + y[i]) >> 3) &
									 1) ? &k_1 : &k_2, screen + act_screen);
	}

	/* eigenen Bildschirm als physikalischen und logischen Schirm setzen  */
	/* und Flag setzen, da erst durch den nchsten Vertical Blank Inter- */
	/* rupt wieder gelscht wird und damit zur Synchronisation dient.	  */

	Setscreen(screen[act_screen].fd_addr, screen[act_screen].fd_addr, -1);
	Was_Vb = 1;

	/* Nun knnen endlich die Kugeln rollen ...							  */

	do
	{

	/* Zuerst die neuen Positionen der Kugen berechnen					  */

		calc_new_pos();

	/* Falls in der Zwischenzeit noch kein Vertical Blank Interrupt auf-  */
	/* getreten ist (wie es durch einen Wert ungleich Null von Was_Vb an- */
	/* gezeigt wird) mu darauf gewartet werden, da dann die Bildschirm-  */
	/* umschaltung noch nicht stattgefunden hat und somit die folgenden	  */
	/* Arbeiten auf dem Bildschirm sichtbar wren.						  */

		if (Was_Vb)
			Vsync();

	/* Nun die Kugeln vom derzeit nicht benutzten Bildchirm lschen		  */

		act_screen ^= 1;

		for (i = j = k = 0, l = 4; i < num_balls; i++, k = l, l += 4)
		{
			vro_cpyfm(wkst_handle, S_ONLY, clear + 8 * i, &old_screen,
													   screen + act_screen);

			clear[k++] = clear[l++] = clear_new[j++];
			clear[k++] = clear[l++] = clear_new[j++];
			clear[k++] = clear[l++] = clear_new[j++];
			clear[k++] = clear[l++] = clear_new[j++];
		}

	/* Kugeln auf den neuen Bildschirm kopieren (erst die Maske per UND-  */
	/* Verknpfung, dann die Kugel per ODER-Verknpfung)				  */

		for (i = 0, j = 0; i < num_balls; i++)
		{
			clear_new[j++] = copy[4] = (int) x[i] - r;
			clear_new[j++] = copy[5] = (int) y[i] - r;
			clear_new[j++] = copy[6] = copy[4] + d;
			clear_new[j++] = copy[7] = copy[5] + d;

			vro_cpyfm(wkst_handle, S_AND_D, copy, &m, screen + act_screen);
			vro_cpyfm(wkst_handle, S_OR_D, copy, (((int) (x[i] + y[i]) >> 3)
								   & 1) ? &k_1 : &k_2, screen + act_screen);
		}
	
	/* neuen Bildschirm als physikalischen und logischen Schirm setzen  */

		Setscreen(screen[act_screen].fd_addr, screen[act_screen].fd_addr,
																		-1);

	/* Flag setzen, da erst durch den nchsten Vertical Blank Interrupt  */
	/* wieder gelscht wird (vorher darf auf dem Bildschirm nichts aus-	  */
	/* gegeben werden													  */

		Was_Vb = 1;

	} while (Counter > max_count); /* solange weitermachen bis der Zhler */
								   /* durch IKBD-Interrupt zurckgesetzt  */
	if (Cconis())
		Crawcin();

	/* Zurck zum alten Bildschirm										  */

	Setscreen(old_log_screen, old_phys_screen, -1);
	v_show_c(wkst_handle, 1);

	/* Allozierten Speicher wieder freigeben							  */

	Mfree(flag_2);
	Mfree(n_kug_1);
	Mfree(ptr);

	v_clsvwk(wkst_handle);						/* Workstation schliessen */
}


/**************************************************************************/
/*																		  */
/*	In dieser Routine werden die neuen Positionen der Kugeln nach einem	  */
/*	bestimmten Zeitintervall (= 1.0) neu berechnet, wobei whrend dieses  */
/*	Zeitraums sowohl Ste mit der Wand als auch von Kugeln untereinander */
/*	auftreten knnen. Es wird allerdings davon ausgegangen, da niemals	  */
/*	mehr als ein Sto zu einem Zeitpunkt auftritt - eine Annahme, die	  */
/*	durch die hohe Zeitauflsung bei der Verwendung von double real Zah-  */
/*  len gerechtfertigt sein drfte.										  */
/*																		  */
/**************************************************************************/


void calc_new_pos(void)
{
	int i, j, k;
	double v_s_x,				/* x-Komponente von v im ruhenden System  */
		   v_s_y,				/* y-Komponente von v im ruhenden System  */
		   d_v,					/* Abstand zur anderen Kugel in Richtung  */
								/* der Bahn								  */
		   v_q,					/* 1 / Betrag der Geschwindigkeit		  */
		   d_x,					/* x-Komponente des Abstands			  */
		   d_y,					/* y-Komponente des Abstands			  */
		   delta,				/* Abstand senkrecht zur Bahn			  */
		   t = 1.0,
		   t_min,				/* tatschliche Zeit bis zum Sto		  */
		   t_test;


	do
	{

	/* Zuerst Zeit bis zu den Sten der Kugeln mit der Wand berechnen	  */

		t_min = HUGE_VAL;

		for (i = 0; i < num_balls; i++)
		{

	/* Falls sich die Geschwindigkeit der Kugel im letzten Durchlauf	  */
	/* nicht gendert hat, mu die Zeit bis zum mglichen Sto mit der	  */
	/* Wand nicht nochmal neu berechnet werden							  */

			if (flag_1[i] == 0)
			{
				t_min = MIN(t_min, t_s[i]);
				continue;
			}

			flag_2[i] = 0;

	/* Zeit bis zum Sto mit linker Wand berechnen						  */

			t_test = (r - x[i]) / v_x[i];
			if ((t_test > EPSILON) && (t_test < t_s[i]))
			{
				t_s[i] = t_test;
				t_min = MIN(t_min, t_test);
			}

	/* Zeit bis zum Sto mit rechter Wand berechnen						  */

			t_test = (right_max - x[i]) / v_x[i];
			if ((t_test > EPSILON) && (t_test < t_s[i]))
			{
				t_s[i] = t_test;
				t_min = MIN(t_min, t_test);
			}

	/* Zeit bis zum Sto mit oberer Wand berechnen						  */

			t_test = (r - y[i]) / v_y[i];
			if ((t_test > EPSILON) && (t_test < t_s[i]))
			{
				flag_2[i] = 1;
				t_s[i] = t_test;
				t_min = MIN(t_min, t_test);
			}

	/* Zeit bis zum Sto mit unterer Wand berechnen						  */

			t_test = (bottom_max - y[i]) / v_y[i];
			if ((t_test > EPSILON) && (t_test < t_s[i]))
			{
				flag_2[i] = 1;
				t_s[i] = t_test;
				t_min = MIN(t_min, t_s[i]);
			}
		}

	/* Nun Zeiten bis zu Zusammensten zwischen den Kugeln berechnen	  */

		k = num_balls;
		for (i = 0; i < num_balls - 1; i++)
		{
			for (j = i + 1; j < num_balls; k++, j++)
			{

	/* Falls die Geschwindigkeiten beider Kugeln sich im letzten Durch-	  */
	/* lauf nicht gendert haben, mssen die Zeiten bis zum mglichen	  */
	/* Sto nicht noch einmal neu berechnet werden						  */

				if (!(flag_1[i] || flag_1[j]))
				{
					t_min = MIN(t_min, t_s[k]);
					continue;
				}

				t_s[k] = HUGE_VAL;

	/* x- und y-Komponente von Abstand (d_x, d_y) und Relativgeschwindig- */
	/* keit (v_x, v_y) sowie Kehrwert des Betrags der Relativgeschwindig- */
	/* keit (v_q) berechnen												  */

				d_x = x[j] - x[i];
				d_y = y[j] - y[i];

				v_s_x = v_x[i] - v_x[j];
				v_s_y = v_y[i] - v_y[j];

				v_q = 1.0 / sqrt(v_s_x * v_s_x + v_s_y * v_s_y);

	/* Abstand in Richtung der Relativgeschwindigkeit (d_v) berechnen und */
	/* abbrechen, wenn die Kugeln auseinanderlaufen (da die Berechnung	  */
	/* ber Vektormultiplikationen erfolgt bedeutet ein negativer Ab-	  */
	/* stand, da die Kugeln sich von einander entfernen)				  */

				d_v = (v_s_x * d_x + v_s_y * d_y) * v_q;

				if (d_v < 0.0)
					continue;

	/* seitlichen Abstand (senkrecht zur Relativgeschwindigkeit) der Ku-  */
	/* geln (delta) berechnen und abbrechen, wenn er grer als 2 r ist	  */

				delta = (v_s_x * d_y - v_s_y * d_x) * v_q;

				if (fabs(delta) > (double) (2 * r))
					continue;

	/* sonst die Zeit bis zum Sto t_s berechnen						  */

				t_s[k] = (d_v - sqrt(4 * r * r - delta * delta)) * v_q;

				t_min = MIN(t_min, t_s[k]);
			}
		}

	/* Neue Koordinaten und Geschwindigkeiten bis zum Sto berechnen	  */

		if (t_min > t)							 /* kein Sto aufgetreten */
		{
			for (i = 0; i < num_balls; i++)
			{
				x[i] += v_x[i] * t;
				y[i] += v_y[i] * t;
				flag_1[i] = 0;
			}

			for (i = 0; i < (num_balls * (num_balls + 1)) / 2; i++)
				t_s[i] -= t;

			return;
		}

		for (i = 0; i < num_balls; i++)
		{
			x[i] += v_x[i] * t_min;
			y[i] += v_y[i] * t_min;

			if (t_s[i] == t_min)
			{
				if (flag_2[i])
					v_y[i] *= -1;
				else
					v_x[i] *= -1;

				t_s[i] = HUGE_VAL;
				flag_1[i] = 1;
			}
			else
			{
				flag_1[i] = 0;
				t_s[i] -= t_min;
			}
		}

		k = num_balls;
		for (i = 0; i < num_balls - 1; i++)
		{
			for (j = i + 1; j < num_balls; k++, j++)
			{
				if (t_s[k] == t_min)
				{

	/* Die Berechnung der neuen Geschwindigkeiten erfolgt in einem Be-	  */
	/* zugssystem, in dem eine der beiden Kugeln ruht, anschliessend er-  */
	/* folgt die Rcktransformation										  */

					d_x = (x[j] - x[i]) / r;
					d_y = (y[j] - y[i]) / r;

					v_s_x = v_x[i] - v_x[j];
					v_s_y = v_y[i] - v_y[j];

					d_v = 0.25 * (v_s_x * d_y - v_s_y * d_x);
					v_q = 0.25 * (v_s_x * d_x + v_s_y * d_y);

					v_x[i] = v_x[j] + d_v *	d_y;
					v_y[i] = v_y[j] - d_v *	d_x;

					v_x[j] += v_q * d_x;
					v_y[j] += v_q * d_y;

					flag_1[i] = flag_1[j] = 1;
					t_s[i] = t_s[j] = HUGE_VAL;
				}
				else
					t_s[k] -= t_min;
			}
		}

	} while ((t -= t_min) > 0);
}


/**************************************************************************/
/*																		  */
/*	Erffnen einer Workstation und Setzen verschiedener Parameter.		  */
/*																		  */
/**************************************************************************/


int gem_init(void)
{
	int work_in[11],				  /* Eingabe- und Ausgabeparameter 	  */
		work_out[57];				  /* fr ffnen der Workstation		  */
	int dummy;


	wkst_handle = graf_handle(&dummy, &dummy,		  /* Handle der Work- */
							  &dummy, &dummy);		  /* station besorgen */

	work_in[0]  = wkst_handle;	   /* verschiedene Parameter der zu ff-  */
								   /* nenden Workstation festsetzen		  */
	work_in[1]  = 1;			   /* Linientyp = durchgezogen			  */
	work_in[2]  = BLACK;		   /* Linienfarbe = schwarz				  */
	work_in[3]  = 1;			   /* Markertyp = Punkt					  */
	work_in[4]  = BLACK;		   /* Markerfarbe = schwarz				  */
	work_in[5]  = 0;			   /* Textstil = Normalschrift			  */
	work_in[6]  = BLACK;		   /* Textfarbe = schwarz				  */
	work_in[7]  = 1;			   /* Flltyp (s. Atari Profibuch S. 328) */
	work_in[8]  = 8;			   /* Fllmuster-Index					  */
	work_in[9]  = BLACK;		   /* Fllmuster-Farbe					  */
	work_in[10] = 2;			   /* Rasterkoordinaten					  */

	v_opnvwk(work_in, &wkst_handle, work_out);	 /* Workstation ffnen	  */

	screen_width = work_out[0] + 1;
	screen_height = work_out[1] + 1;

	nplanes = 0;
	while (work_out[13] >>= 1)
		nplanes++;

	right_max = screen_width - 1 - r;
	bottom_max = screen_height - 1 - r;

	return(1);
}


/**************************************************************************/
/*																		  */
/*	Routine zum Editieren von Wartezeit, Anzahl der Kugeln und ihrer	  */
/*	Maximalgeschwindigkeit.												  */
/*																		  */
/**************************************************************************/


void edit_parameter(void)
{
	int ret_ob;

/*#################################################*/
/* Hier sollte bei der ST-Version 'num = 3' stehen */
/* und in der TT-Version 'num = 10'				   */
/*#################################################*/

	static int num = 10, vel = 50;
	static long time = 1;
	int c[12];
	MFDB scr, mem;


	if (!gem_init())
		return;

	/* Verhindern, da das AES sich einmischt							  */

	wind_update(BEG_MCTRL);

	form_center(rs_object, c, c + 1, c + 2, c + 3);

	c[8] = c[0];					/* Array zun Kopieren mit vro_cpyfm() */
	c[9] = c[1];					/* vorbereiten						  */
	c[10] = c[0] + c[2];
	c[11] = c[1] + c[3];

	c[4] = c[5] = 0;

	/* Bildschirm abspeichern											  */

	mem.fd_w = c[6] = c[2];
	mem.fd_h = c[7] = c[3];
	mem.fd_wdwidth = c[2] / 16 + 1;
	mem.fd_stand = 0;
	mem.fd_nplanes = nplanes;

	if ((mem.fd_addr = Malloc((long) nplanes * 2 * mem.fd_wdwidth * c[7]))
																	   == 0)
	{
		v_clsvwk(wkst_handle);					/* Workstation schliessen */
		wind_update(END_MCTRL);
		return;
	}

	scr.fd_addr = 0L;

	c[2] = c[10];
	c[3] = c[11];

	v_hide_c(wkst_handle);
	vro_cpyfm(wkst_handle, S_ONLY, c, &scr, &mem);
	v_show_c(wkst_handle, 0);

	/* Formular zeichnen												  */

	objc_draw(rs_object, R_TREE, 1, c[0], c[1], c[2], c[3]);

	do
	{
		ret_ob = form_do(rs_object, 0);

		switch (ret_ob)
		{
			case CRTLM1 :				  /* '-' bei Wartezeiteinstellung */
				if (time != 0)
				{
					--time;
					if (time == 0)
						strcpy(rs_object[CRTLT1].ob_spec.free_string,
																	 "AUS");
					else
						i_to_a(rs_object[CRTLT1].ob_spec.free_string,
																(int) time);
				}
				rs_object[CRTLM1].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLM1, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT1, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLP1 :				  /* '+' bei Wartezeiteinstellung */
				time = MIN(99, time + 1);
				i_to_a(rs_object[CRTLT1].ob_spec.free_string, (int) time);
				rs_object[CRTLP1].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLP1, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT1, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLM2 :						   /* '-' bei Kugelanzahl */
				num = MAX(1, num - 1);
				i_to_a(rs_object[CRTLT2].ob_spec.free_string, num);
				rs_object[CRTLM2].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLM2, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT2, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLP2 :						   /* '+' bei Kugelanzahl */
				num = MIN(49, num + 1);
				i_to_a(rs_object[CRTLT2].ob_spec.free_string, num);
				rs_object[CRTLP2].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLP2, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT2, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLMM3 :		  /* '--' bei Geschwindigkeitseinstellung */
				vel = MAX(1, vel - 10);
				i_to_a(rs_object[CRTLT3].ob_spec.free_string, vel);
				rs_object[CRTLMM3].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLMM3, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT3, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLM3 :		   /* '-' bei Geschwindigkeitseinstellung */
				vel = MAX(1, vel - 1);
				i_to_a(rs_object[CRTLT3].ob_spec.free_string, vel);
				rs_object[CRTLM3].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLM3, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT3, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLP3 :		   /* '+' bei Geschwindigkeitseinstellung */
				vel = MIN(99, vel + 1);
				i_to_a(rs_object[CRTLT3].ob_spec.free_string, vel);
				rs_object[CRTLP3].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLP3, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT3, 0, c[0], c[1], c[2], c[3]);
				break;

			case CRTLPP3 :		  /* '++' bei Geschwindigkeitseinstellung */
				vel = MIN(99, vel + 10);
				i_to_a(rs_object[CRTLT3].ob_spec.free_string, vel);
				rs_object[CRTLPP3].ob_state &= ~SELECTED;
				objc_draw(rs_object, CRTLPP3, 0, c[0], c[1], c[2], c[3]);
				objc_draw(rs_object, CRTLT3, 0, c[0], c[1], c[2], c[3]);
				break;

			default :
				break;
		}
	} while ((ret_ob != CRTLA) && (ret_ob != CRTLS) && (ret_ob != CRTLF));

	evnt_timer(250, 0);
	while (Cconis())							 /* Tastaturbuffer leeren */
		Crawcin();

	switch (ret_ob)
	{
		case CRTLA :										   /* Abbruch */
			time = max_count / (60 * VBI_per_sec);
			if (time == 0)
				strcpy(rs_object[CRTLT1].ob_spec.free_string, "AUS");
			else
				i_to_a(rs_object[CRTLT1].ob_spec.free_string, (int) time);
			i_to_a(rs_object[CRTLT2].ob_spec.free_string, num);
			i_to_a(rs_object[CRTLT3].ob_spec.free_string, vel);
			rs_object[CRTLA].ob_state &= ~SELECTED;
			break;

		case CRTLS :										   /* Starten */
			max_count = -time * 60 * VBI_per_sec;
			num_balls = num;
			speed = vel;
			rs_object[CRTLS].ob_state &= ~SELECTED;
			break;

		case CRTLF :											/* Fertig */
			max_count = time * 60 * VBI_per_sec;
			num_balls = num;
			speed = vel;
			rs_object[CRTLF].ob_state &= ~SELECTED;
			break;

		default :
			break;
	}

	v_hide_c(wkst_handle);
	vro_cpyfm(wkst_handle, S_ONLY, c + 4, &mem, &scr);
	v_show_c(wkst_handle, 0);

	Mfree(mem.fd_addr);
	v_clsvwk(wkst_handle);						/* Workstation schliessen */

	wind_update(END_MCTRL);
}


/**************************************************************************/
/*																		  */
/*	Pseudo-Zufallsgenerator (aus Handbuch zum HP-47)					  */
/*																		  */
/**************************************************************************/


double get_rand(void)
{
	static double long x = 0.0;

	return (x = fmod(9821.0 * x + 0.211327, 1.0));
}


/**************************************************************************/
/*																		  */
/*	Routine zum Wandeln eines Strings, der eine Zahl enthlt in eine	  */
/*	(vorzeichenlose) Integer-Zahl.										  */
/*																		  */
/**************************************************************************/


void i_to_a(char *str, int n)
{
	*(str + 1) = (char) (n % 10) + '0';
	*str = (char) (n / 10) + '0';
	if (*str == '0')							
		*str++ = ' ';
}